# coding: utf-8

"""
    Oliver API

    Oliver API service  # noqa: E501

    OpenAPI spec version: 4.3.0
    Contact: api@behavioralsignals.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Speaker(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'SpeakerId',
        'created_at': 'datetime',
        'active_at': 'datetime',
        'total_calls': 'int',
        'total_speech_duration': 'float',
        'portfolios': 'list[PortfolioId]'
    }

    attribute_map = {
        'id': 'id',
        'created_at': 'created_at',
        'active_at': 'active_at',
        'total_calls': 'totalCalls',
        'total_speech_duration': 'totalSpeechDuration',
        'portfolios': 'portfolios'
    }

    def __init__(self, id=None, created_at=None, active_at=None, total_calls=None, total_speech_duration=None, portfolios=None):  # noqa: E501
        """Speaker - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_at = None
        self._active_at = None
        self._total_calls = None
        self._total_speech_duration = None
        self._portfolios = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if created_at is not None:
            self.created_at = created_at
        if active_at is not None:
            self.active_at = active_at
        if total_calls is not None:
            self.total_calls = total_calls
        if total_speech_duration is not None:
            self.total_speech_duration = total_speech_duration
        if portfolios is not None:
            self.portfolios = portfolios

    @property
    def id(self):
        """Gets the id of this Speaker.  # noqa: E501


        :return: The id of this Speaker.  # noqa: E501
        :rtype: SpeakerId
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Speaker.


        :param id: The id of this Speaker.  # noqa: E501
        :type: SpeakerId
        """

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this Speaker.  # noqa: E501

        The date time when was created  # noqa: E501

        :return: The created_at of this Speaker.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Speaker.

        The date time when was created  # noqa: E501

        :param created_at: The created_at of this Speaker.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def active_at(self):
        """Gets the active_at of this Speaker.  # noqa: E501

        The latest date time when was active  # noqa: E501

        :return: The active_at of this Speaker.  # noqa: E501
        :rtype: datetime
        """
        return self._active_at

    @active_at.setter
    def active_at(self, active_at):
        """Sets the active_at of this Speaker.

        The latest date time when was active  # noqa: E501

        :param active_at: The active_at of this Speaker.  # noqa: E501
        :type: datetime
        """

        self._active_at = active_at

    @property
    def total_calls(self):
        """Gets the total_calls of this Speaker.  # noqa: E501

        The number of calls the speaker appeared in.  # noqa: E501

        :return: The total_calls of this Speaker.  # noqa: E501
        :rtype: int
        """
        return self._total_calls

    @total_calls.setter
    def total_calls(self, total_calls):
        """Sets the total_calls of this Speaker.

        The number of calls the speaker appeared in.  # noqa: E501

        :param total_calls: The total_calls of this Speaker.  # noqa: E501
        :type: int
        """

        self._total_calls = total_calls

    @property
    def total_speech_duration(self):
        """Gets the total_speech_duration of this Speaker.  # noqa: E501

        The total duration (in seconds) of speech made available for this speaker  # noqa: E501

        :return: The total_speech_duration of this Speaker.  # noqa: E501
        :rtype: float
        """
        return self._total_speech_duration

    @total_speech_duration.setter
    def total_speech_duration(self, total_speech_duration):
        """Sets the total_speech_duration of this Speaker.

        The total duration (in seconds) of speech made available for this speaker  # noqa: E501

        :param total_speech_duration: The total_speech_duration of this Speaker.  # noqa: E501
        :type: float
        """

        self._total_speech_duration = total_speech_duration

    @property
    def portfolios(self):
        """Gets the portfolios of this Speaker.  # noqa: E501


        :return: The portfolios of this Speaker.  # noqa: E501
        :rtype: list[PortfolioId]
        """
        return self._portfolios

    @portfolios.setter
    def portfolios(self, portfolios):
        """Sets the portfolios of this Speaker.


        :param portfolios: The portfolios of this Speaker.  # noqa: E501
        :type: list[PortfolioId]
        """

        self._portfolios = portfolios

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Speaker, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Speaker):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
